| AI Engine Intrinsics User Guide (AIE) v2025.2

Loading...
Searching...
No Matches
Initialization
Intrinsics » Vector Operations

## Overview

Initialization intrinsics for accumulator and vector types.

The "undef" functions are used to create a vector variable without the compiler giving a "using undefined variable" warning.

The "null" functions return a vector object of the given type with all of its values set to 0, and can be used to zero out a vector variable.

## Null vectors
Returns a vector with all values set to 0.
v16int8 const | null_v16int8 ()
v16uint8 const | null_v16uint8 ()
v8int16 const | null_v8int16 ()
v4cint16 const | null_v4cint16 ()
v4int32 const | null_v4int32 ()
v2cint32 const | null_v2cint32 ()
v4float const | null_v4float ()
v2cfloat const | null_v2cfloat ()
v32int8 const | null_v32int8 ()
v32uint8 const | null_v32uint8 ()
v16int16 const | null_v16int16 ()
v8cint16 const | null_v8cint16 ()
v8int32 const | null_v8int32 ()
v4cint32 const | null_v4cint32 ()
v8float const | null_v8float ()
v4cfloat const | null_v4cfloat ()
v64int8 const | null_v64int8 ()
v128int8 const | null_v128int8 ()
v64uint8 const | null_v64uint8 ()
v128uint8 const | null_v128uint8 ()
v32int16 const | null_v32int16 ()
v64int16 const | null_v64int16 ()
v16cint16 const | null_v16cint16 ()
v32cint16 const | null_v32cint16 ()
v16int32 const | null_v16int32 ()
v32int32 const | null_v32int32 ()
v8cint32 const | null_v8cint32 ()
v16cint32 const | null_v16cint32 ()
v16float const | null_v16float ()
v32float const | null_v32float ()
v8cfloat const | null_v8cfloat ()
v16cfloat const | null_v16cfloat ()
v8acc48 const | null_v8acc48 ()
v4cacc48 const | null_v4cacc48 ()
v4acc80 const | null_v4acc80 ()
v2cacc80 const | null_v2cacc80 ()
v16acc48 const | null_v16acc48 ()
v8cacc48 const | null_v8cacc48 ()
v8acc80 const | null_v8acc80 ()
v4cacc80 const | null_v4cacc80 ()
v4accfloat const | null_v4accfloat ()
v8accfloat const | null_v8accfloat ()
v16accfloat const | null_v16accfloat ()
v32accfloat const | null_v32accfloat ()
v2caccfloat const | null_v2caccfloat ()
v4caccfloat const | null_v4caccfloat ()
v8caccfloat const | null_v8caccfloat ()
v16caccfloat const | null_v16caccfloat ()

## Initialization functions for 128-bit Vectors
v16int8 | undef_v16int8 ()
v16uint8 | undef_v16uint8 ()
v8int16 | undef_v8int16 ()
v4cint16 | undef_v4cint16 ()
v4int32 | undef_v4int32 ()
v2cint32 | undef_v2cint32 ()
v4float | undef_v4float ()
v2cfloat | undef_v2cfloat ()

## Initialization functions for 256-bit Vectors
v32int8 | undef_v32int8 ()
v32uint8 | undef_v32uint8 ()
v16int16 | undef_v16int16 ()
v8cint16 | undef_v8cint16 ()
v8int32 | undef_v8int32 ()
v4cint32 | undef_v4cint32 ()
v8float | undef_v8float ()
v4cfloat | undef_v4cfloat ()

## Initialization functions for 512-bit Vectors
v64int8 | undef_v64int8 ()
v64uint8 | undef_v64uint8 ()
v32int16 | undef_v32int16 ()
v16cint16 | undef_v16cint16 ()
v16int32 | undef_v16int32 ()
v8cint32 | undef_v8cint32 ()
v16float | undef_v16float ()
v8cfloat | undef_v8cfloat ()

## Initialization functions for 1024-bit Vectors
v128int8 | undef_v128int8 ()
v128uint8 | undef_v128uint8 ()
v64int16 | undef_v64int16 ()
v32cint16 | undef_v32cint16 ()
v32int32 | undef_v32int32 ()
v16cint32 | undef_v16cint32 ()
v32float | undef_v32float ()
v16cfloat | undef_v16cfloat ()

## Initialization functions for Accumulators
v8acc48 | undef_v8acc48 ()
v4cacc48 | undef_v4cacc48 ()
v4acc80 | undef_v4acc80 ()
v2cacc80 | undef_v2cacc80 ()
v16acc48 | undef_v16acc48 ()
v8cacc48 | undef_v8cacc48 ()
v8acc80 | undef_v8acc80 ()
v4cacc80 | undef_v4cacc80 ()

## Initialization functions for floating point Accumulators
v4accfloat | undef_v4accfloat ()
v2caccfloat | undef_v2caccfloat ()
v8accfloat | undef_v8accfloat ()
v4caccfloat | undef_v4caccfloat ()
v16accfloat | undef_v16accfloat ()
v8caccfloat | undef_v8caccfloat ()
v32accfloat | undef_v32accfloat ()
v16caccfloat | undef_v16caccfloat ()

## Function Documentation

## ◆ null_v128int8()

v128int8 const null_v128int8 | ( |  | ) |

## ◆ null_v128uint8()

v128uint8 const null_v128uint8 | ( |  | ) |

## ◆ null_v16acc48()

v16acc48 const null_v16acc48 | ( |  | ) |

## ◆ null_v16accfloat()

v16accfloat const null_v16accfloat | ( |  | ) |

## ◆ null_v16caccfloat()

v16caccfloat const null_v16caccfloat | ( |  | ) |

## ◆ null_v16cfloat()

v16cfloat const null_v16cfloat | ( |  | ) |

## ◆ null_v16cint16()

v16cint16 const null_v16cint16 | ( |  | ) |

## ◆ null_v16cint32()

v16cint32 const null_v16cint32 | ( |  | ) |

## ◆ null_v16float()

v16float const null_v16float | ( |  | ) |

## ◆ null_v16int16()

v16int16 const null_v16int16 | ( |  | ) |

## ◆ null_v16int32()

v16int32 const null_v16int32 | ( |  | ) |

## ◆ null_v16int8()

v16int8 const null_v16int8 | ( |  | ) |

## ◆ null_v16uint8()

v16uint8 const null_v16uint8 | ( |  | ) |

## ◆ null_v2cacc80()

v2cacc80 const null_v2cacc80 | ( |  | ) |

## ◆ null_v2caccfloat()

v2caccfloat const null_v2caccfloat | ( |  | ) |

## ◆ null_v2cfloat()

v2cfloat const null_v2cfloat | ( |  | ) |

## ◆ null_v2cint32()

v2cint32 const null_v2cint32 | ( |  | ) |

## ◆ null_v32accfloat()

v32accfloat const null_v32accfloat | ( |  | ) |

## ◆ null_v32cint16()

v32cint16 const null_v32cint16 | ( |  | ) |

## ◆ null_v32float()

v32float const null_v32float | ( |  | ) |

## ◆ null_v32int16()

v32int16 const null_v32int16 | ( |  | ) |

## ◆ null_v32int32()

v32int32 const null_v32int32 | ( |  | ) |

## ◆ null_v32int8()

v32int8 const null_v32int8 | ( |  | ) |

## ◆ null_v32uint8()

v32uint8 const null_v32uint8 | ( |  | ) |

## ◆ null_v4acc80()

v4acc80 const null_v4acc80 | ( |  | ) |

## ◆ null_v4accfloat()

v4accfloat const null_v4accfloat | ( |  | ) |

## ◆ null_v4cacc48()

v4cacc48 const null_v4cacc48 | ( |  | ) |

## ◆ null_v4cacc80()

v4cacc80 const null_v4cacc80 | ( |  | ) |

## ◆ null_v4caccfloat()

v4caccfloat const null_v4caccfloat | ( |  | ) |

## ◆ null_v4cfloat()

v4cfloat const null_v4cfloat | ( |  | ) |

## ◆ null_v4cint16()

v4cint16 const null_v4cint16 | ( |  | ) |

## ◆ null_v4cint32()

v4cint32 const null_v4cint32 | ( |  | ) |

## ◆ null_v4float()

v4float const null_v4float | ( |  | ) |

## ◆ null_v4int32()

v4int32 const null_v4int32 | ( |  | ) |

## ◆ null_v64int16()

v64int16 const null_v64int16 | ( |  | ) |

## ◆ null_v64int8()

v64int8 const null_v64int8 | ( |  | ) |

## ◆ null_v64uint8()

v64uint8 const null_v64uint8 | ( |  | ) |

## ◆ null_v8acc48()

v8acc48 const null_v8acc48 | ( |  | ) |

## ◆ null_v8acc80()

v8acc80 const null_v8acc80 | ( |  | ) |

## ◆ null_v8accfloat()

v8accfloat const null_v8accfloat | ( |  | ) |

## ◆ null_v8cacc48()

v8cacc48 const null_v8cacc48 | ( |  | ) |

## ◆ null_v8caccfloat()

v8caccfloat const null_v8caccfloat | ( |  | ) |

## ◆ null_v8cfloat()

v8cfloat const null_v8cfloat | ( |  | ) |

## ◆ null_v8cint16()

v8cint16 const null_v8cint16 | ( |  | ) |

## ◆ null_v8cint32()

v8cint32 const null_v8cint32 | ( |  | ) |

## ◆ null_v8float()

v8float const null_v8float | ( |  | ) |

## ◆ null_v8int16()

v8int16 const null_v8int16 | ( |  | ) |

## ◆ null_v8int32()

v8int32 const null_v8int32 | ( |  | ) |

## ◆ undef_v128int8()

v128int8 undef_v128int8 | ( |  | ) |

## ◆ undef_v128uint8()

v128uint8 undef_v128uint8 | ( |  | ) |

## ◆ undef_v16acc48()

v16acc48 undef_v16acc48 | ( |  | ) |

## ◆ undef_v16accfloat()

v16accfloat undef_v16accfloat | ( |  | ) |

## ◆ undef_v16caccfloat()

v16caccfloat undef_v16caccfloat | ( |  | ) |

## ◆ undef_v16cfloat()

v16cfloat undef_v16cfloat | ( |  | ) |

## ◆ undef_v16cint16()

v16cint16 undef_v16cint16 | ( |  | ) |

## ◆ undef_v16cint32()

v16cint32 undef_v16cint32 | ( |  | ) |

## ◆ undef_v16float()

v16float undef_v16float | ( |  | ) |

## ◆ undef_v16int16()

v16int16 undef_v16int16 | ( |  | ) |

## ◆ undef_v16int32()

v16int32 undef_v16int32 | ( |  | ) |

## ◆ undef_v16int8()

v16int8 undef_v16int8 | ( |  | ) |

## ◆ undef_v16uint8()

v16uint8 undef_v16uint8 | ( |  | ) |

## ◆ undef_v2cacc80()

v2cacc80 undef_v2cacc80 | ( |  | ) |

## ◆ undef_v2caccfloat()

v2caccfloat undef_v2caccfloat | ( |  | ) |

## ◆ undef_v2cfloat()

v2cfloat undef_v2cfloat | ( |  | ) |

## ◆ undef_v2cint32()

v2cint32 undef_v2cint32 | ( |  | ) |

## ◆ undef_v32accfloat()

v32accfloat undef_v32accfloat | ( |  | ) |

## ◆ undef_v32cint16()

v32cint16 undef_v32cint16 | ( |  | ) |

## ◆ undef_v32float()

v32float undef_v32float | ( |  | ) |

## ◆ undef_v32int16()

v32int16 undef_v32int16 | ( |  | ) |

## ◆ undef_v32int32()

v32int32 undef_v32int32 | ( |  | ) |

## ◆ undef_v32int8()

v32int8 undef_v32int8 | ( |  | ) |

## ◆ undef_v32uint8()

v32uint8 undef_v32uint8 | ( |  | ) |

## ◆ undef_v4acc80()

v4acc80 undef_v4acc80 | ( |  | ) |

## ◆ undef_v4accfloat()

v4accfloat undef_v4accfloat | ( |  | ) |

## ◆ undef_v4cacc48()

v4cacc48 undef_v4cacc48 | ( |  | ) |

## ◆ undef_v4cacc80()

v4cacc80 undef_v4cacc80 | ( |  | ) |

## ◆ undef_v4caccfloat()

v4caccfloat undef_v4caccfloat | ( |  | ) |

## ◆ undef_v4cfloat()

v4cfloat undef_v4cfloat | ( |  | ) |

## ◆ undef_v4cint16()

v4cint16 undef_v4cint16 | ( |  | ) |

## ◆ undef_v4cint32()

v4cint32 undef_v4cint32 | ( |  | ) |

## ◆ undef_v4float()

v4float undef_v4float | ( |  | ) |

## ◆ undef_v4int32()

v4int32 undef_v4int32 | ( |  | ) |

## ◆ undef_v64int16()

v64int16 undef_v64int16 | ( |  | ) |

## ◆ undef_v64int8()

v64int8 undef_v64int8 | ( |  | ) |

## ◆ undef_v64uint8()

v64uint8 undef_v64uint8 | ( |  | ) |

## ◆ undef_v8acc48()

v8acc48 undef_v8acc48 | ( |  | ) |

## ◆ undef_v8acc80()

v8acc80 undef_v8acc80 | ( |  | ) |

## ◆ undef_v8accfloat()

v8accfloat undef_v8accfloat | ( |  | ) |

## ◆ undef_v8cacc48()

v8cacc48 undef_v8cacc48 | ( |  | ) |

## ◆ undef_v8caccfloat()

v8caccfloat undef_v8caccfloat | ( |  | ) |

## ◆ undef_v8cfloat()

v8cfloat undef_v8cfloat | ( |  | ) |

## ◆ undef_v8cint16()

v8cint16 undef_v8cint16 | ( |  | ) |

## ◆ undef_v8cint32()

v8cint32 undef_v8cint32 | ( |  | ) |

## ◆ undef_v8float()

v8float undef_v8float | ( |  | ) |

## ◆ undef_v8int16()

v8int16 undef_v8int16 | ( |  | ) |

## ◆ undef_v8int32()

v8int32 undef_v8int32 | ( |  | ) |